#region Using declarations
using System;
using System.ComponentModel;
using System.Diagnostics;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    /// <summary>
    /// Pivot Swings based on Unlocking the market timing!
    /// </summary>
    [Description("Pivot Swings based on Unlocking the market timing!")]
    public class PivotSwing : Indicator
    {
        #region Variables
        // Wizard generated variables
        // User defined variables (add any user defined variables below)
		
		
		 
        #endregion
		//DataSeries lowPivots,highPivots; 
        /// <summary>
        /// This method is used to configure the indicator and is called once before any bar data is loaded.
        /// </summary>
        protected override void Initialize()
        {
            Add(new Plot(Color.LimeGreen, PlotStyle.Block, "Pivot Swings"));
			Plots[0].Pen.Width = 0.7F;
			DisplayInDataBox	= false;
            Overlay				= true;
			PaintPriceMarkers	= false;
			
			
        }

        /// <summary>
        /// Called on each bar update event (incoming tick)
        /// </summary>
	
			public bool isPivotHigh (int barsAgo, int leftBarsAgo) {
				double start = Close[barsAgo];
			
			    //check right side
				int bars = 0;
				double bar_one_close = start;
				for (int i=barsAgo-1;i>=0;i--) {
					if (bars ==0 && Close[i]>start)
						return false;
					else if (bars ==0 && Close[i]<=start) {
						bars =1;
						bar_one_close = Close[i];
					} 	
					else if (bars==1 && Close[i] > start)
						return false;
					else if (bars==1 && (Close[i]<= bar_one_close && (Close[i]!=start || Close[i]<bar_one_close))) {
						bars  = 2; 
						break; 
					}	
				}		
				if (bars!=2) return false;
				
				//check left side
				bars = 0; bar_one_close = start;
				for (int i=barsAgo+1;i<=leftBarsAgo;i++) {					
					if (bars ==0 && Close[i]>start)
						return false;
					else if (bars ==0 && Close[i]<start) {
						bars =1;
						bar_one_close = Close[i];
						
					} 
					
					else if (bars==1 && Close[i] > start)
						return false;
					else if (bars==1 && Close[i]< start ) {
						bars  = 2; 
						return true;
					}	
				}
			return false;
		}
				
		
		
		public bool isPivotLow (int barsAgo, int leftBarsAgo) {
				double start = Close[barsAgo];
			
			    //check right side
				int bars = 0;
				double bar_one_close = start;
				for (int i=barsAgo-1;i>=0;i--) {
					if (bars ==0 && Close[i]<start)
						return false;
					else if (bars ==0 && Close[i]>=start) {
						bars =1;
						bar_one_close = Close[i];
					} 	
					else if (bars==1 && Close[i] < start)
						return false;
					else if (bars==1 && (Close[i]>= bar_one_close && (bar_one_close!=start || Close[i]>bar_one_close))) {
						bars  = 2; 
						break; 
					}	
				}		
				if (bars!=2) return false;
				//check left side
				bars = 0; bar_one_close = start;
				for (int i=barsAgo+1;i<=leftBarsAgo;i++) {					
					if (bars ==0 && Close[i]<start)
						return false;
					else if (bars ==0 && Close[i]>start) {
						bars =1;
						bar_one_close = Close[i];
						if (Close[i]>Close[barsAgo+1]) return true;
					} 
					
					else if (bars==1 && Close[i] <start)
						return false;
					else if (bars==1 && Close[i]> start ) {
						bars  = 2; 
						return true;
					}	
				}
			return false;
		}
		
		
		
		int prevType = 0; 
		int lastPivotBar = -1; 
		
        protected override void OnBarUpdate()
        {
   			//need 	at least 5 bars
			//Plot0.Set(0,0); Value.Reset(0); 
		    if (CurrentBar<4) {
				 Value.Reset(0);
				return;
			}
			Value.Reset(0);
			
			int leftBarsAgo =  (lastPivotBar==-1? CurrentBar: CurrentBar- lastPivotBar) ;
		
			for (int i = lastPivotBar+1; i<=CurrentBar-2; i++) { 
				int barsAgo = CurrentBar-i; 

				if (isPivotHigh(barsAgo,leftBarsAgo) && (prevType == 1 || prevType==0)) {	
					lastPivotBar = i;
					prevType = 1;	
					Value.Set(barsAgo,High[barsAgo]);  PlotColors[0][barsAgo] = Color.DodgerBlue;
				}
				else if (isPivotLow(barsAgo,leftBarsAgo) && (prevType == 1 || prevType==0)) {
					lastPivotBar = i;
					prevType = 1;
                    Value.Set(barsAgo,Low[barsAgo]); PlotColors[0][barsAgo] = Color.LimeGreen; 
	
				}
				else {
					Value.Reset(barsAgo); 
				}
			}
			
			
        }

        #region Properties
        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries Plot0
        {
            get { return Values[0]; }
        }

        #endregion
    }
}

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private PivotSwing[] cachePivotSwing = null;

        private static PivotSwing checkPivotSwing = new PivotSwing();

        /// <summary>
        /// Pivot Swings based on Unlocking the market timing!
        /// </summary>
        /// <returns></returns>
        public PivotSwing PivotSwing()
        {
            return PivotSwing(Input);
        }

        /// <summary>
        /// Pivot Swings based on Unlocking the market timing!
        /// </summary>
        /// <returns></returns>
        public PivotSwing PivotSwing(Data.IDataSeries input)
        {
            if (cachePivotSwing != null)
                for (int idx = 0; idx < cachePivotSwing.Length; idx++)
                    if (cachePivotSwing[idx].EqualsInput(input))
                        return cachePivotSwing[idx];

            lock (checkPivotSwing)
            {
                if (cachePivotSwing != null)
                    for (int idx = 0; idx < cachePivotSwing.Length; idx++)
                        if (cachePivotSwing[idx].EqualsInput(input))
                            return cachePivotSwing[idx];

                PivotSwing indicator = new PivotSwing();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                Indicators.Add(indicator);
                indicator.SetUp();

                PivotSwing[] tmp = new PivotSwing[cachePivotSwing == null ? 1 : cachePivotSwing.Length + 1];
                if (cachePivotSwing != null)
                    cachePivotSwing.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cachePivotSwing = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// Pivot Swings based on Unlocking the market timing!
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.PivotSwing PivotSwing()
        {
            return _indicator.PivotSwing(Input);
        }

        /// <summary>
        /// Pivot Swings based on Unlocking the market timing!
        /// </summary>
        /// <returns></returns>
        public Indicator.PivotSwing PivotSwing(Data.IDataSeries input)
        {
            return _indicator.PivotSwing(input);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// Pivot Swings based on Unlocking the market timing!
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.PivotSwing PivotSwing()
        {
            return _indicator.PivotSwing(Input);
        }

        /// <summary>
        /// Pivot Swings based on Unlocking the market timing!
        /// </summary>
        /// <returns></returns>
        public Indicator.PivotSwing PivotSwing(Data.IDataSeries input)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.PivotSwing(input);
        }
    }
}
#endregion
